import arcpy
# arcpy.env.workspace = "S:/Ideiglenes/bevprog/adatok" # én inkább mindent átmásoltam ide

print(help(arcpy.analysis.Buffer))
import arcpy.analysis as ana
ana.Buffer()
arcpy.Buffer_analysis()

import arcpy.management as man
man.Copy(in_data = "folyok.shp", out_data = "folyok_masolat.shp")
man.Copy(in_data = "folyok.shp", out_data = "folyok_masolat.shp") # hibát dob, már létezik a fájl
arcpy.env.overwriteOutput # hamis
arcpy.env.overwriteOutput = True # innentől írja felül kérdés nélkül a meglévő fájlokat!
man.Copy(in_data = "folyok.shp", out_data = "folyok_masolat.shp") # most már lefut

man.Delete(in_data = "folyok_masolat.shp")

# Másolatokat hozunk létre, hogy ne az eredetieket módosítsuk:
man.Copy(in_data = "folyok.shp", out_data = "folyok2.shp")
man.Copy(in_data = "felszinhomerseklet.tif", out_data = "felszinhomerseklet2.tif")

arcpy.Describe("felszinhomerseklet2.tif").spatialReference.name # hiányzik a vetület (EOV)
arcpy.Describe("folyok2.shp").spatialReference.name # EOV
EOV_vetulet = arcpy.Describe("folyok2.shp").spatialReference
man.DefineProjection(in_dataset = "felszinhomerseklet2.tif", coor_system = EOV_vetulet)
arcpy.Describe("felszinhomerseklet2.tif").spatialReference.name # most már jó
arcpy.Describe("varosok.shp").spatialReference.name # u'Hotine_Oblique_Mercator_Azimuth_Center'
man.Project(in_dataset = "varosok.shp", out_dataset = "varosok_eov.shp", out_coor_system = EOV_vetulet)
arcpy.Describe("varosok_eov.shp").spatialReference.name # sikerült az átvetítés

man.AddField(in_table = "folyok2.shp", field_name = "kategoria", field_type = "TEXT") # létrehozunk egy új szövegmezőt
man.DeleteField(in_table = "folyok2.shp", drop_field = "kategoria") # kitöröljük a mezőt

man.AddField(in_table = "folyok2.shp", field_name = "hossz_m", field_type = "FLOAT") # létrehozunk új számmezőt
man.CalculateField(in_table = "folyok2.shp", field = "hossz_m", expression = "[length] * 1000")

elemek_szama = man.GetCount(in_rows = "folyok2.shp")
type(elemek_szama) # Result típusú objektum
print(elemek_szama) # 49
elemek_szama * 2 # hiba, nem tudunk vele tovább dolgozni
int(elemek_szama.getOutput(0)) * 2

man.MakeFeatureLayer(in_features = "folyok2.shp", out_layer = "folyok_retegkent") # ideiglenes vektorréteg
man.MakeTableView(in_table = "folyok2.shp", out_view = "folyok_tabla") # ideiglenes attribútumtábla
man.CopyFeatures(in_features = "folyok_retegkent", out_feature_class = "folyok3.shp") # ideiglenes vektorréteg másolása fájlba (mentése)
