import arcpy
import arcpy.analysis as ana
import arcpy.management as man
# arcpy.env.workspace = "S:/Ideiglenes/bevprog/adatok" # én inkább mindent átmásoltam ide

# a 21_eszkozok_hasznalata_orai.py-bol ezeket mindenkepp futtatni kellett:
# man.Copy(in_data = "folyok.shp", out_data = "folyok2.shp")
# man.AddField(in_table = "folyok2.shp", field_name = "hossz_m", field_type = "FLOAT") # létrehozunk új számmezőt
# man.CalculateField(in_table = "folyok2.shp", field = "hossz_m", expression = "[length] * 1000")
# man.MakeFeatureLayer(in_features = "folyok2.shp", out_layer = "folyok_retegkent") # ideiglenes vektorréteg
# man.CopyFeatures(in_features = "folyok_retegkent", out_feature_class = "folyok3.shp") # ideiglenes vektorréteg másolása fájlba (mentése)

print("\"orszagnev\" = 'Ausztria'") # "orszagnev" = 'Ausztria'
print('"orszagnev" = \'Ausztria\'') # "orszagnev" = 'Ausztria'

print(man.GetCount(in_rows = "folyok_retegkent")) # 49
man.SelectLayerByAttribute(in_layer_or_view = "folyok2.shp", selection_type = "NEW_SELECTION", where_clause = "\"hossz_m\" > 1000") # hibát dob, vektorfájlt nem fogad bemenetként
man.SelectLayerByAttribute(in_layer_or_view = "folyok_retegkent", selection_type = "NEW_SELECTION", where_clause = "\"hossz_m\" > 1000")
print(man.GetCount(in_rows = "folyok_retegkent")) # 40
man.SelectLayerByAttribute(in_layer_or_view = "folyok_retegkent", selection_type = "SWITCH_SELECTION") # megfordítjuk a kijelölést
print(man.GetCount(in_rows = "folyok_retegkent")) # 9
man.CopyFeatures(in_features = "folyok_retegkent", out_feature_class = "rovid_folyok.shp") # mentés

man.MakeFeatureLayer(in_features = "varosok.shp", out_layer = "varosok_retegkent") # ideiglenes vektorréteg
for telepulestipus in ["town", "village"]:
    szuro = "\"type\" = '" + telepulestipus + "'" # összerakja a lekérdezést
    print(szuro) # pl. "type" = 'town'
    man.SelectLayerByAttribute(in_layer_or_view = "varosok_retegkent", selection_type = "NEW_SELECTION", where_clause = szuro)
    elemek_szama = int(man.GetCount(in_rows = "varosok_retegkent").getOutput(0))
    fajlnev = telepulestipus + "_" + str(elemek_szama) + ".shp" # összerakja a mentendő fájl nevét
    man.CopyFeatures(in_features = "varosok_retegkent", out_feature_class = fajlnev)
man.SelectLayerByAttribute(in_layer_or_view = "varosok_retegkent", selection_type = "CLEAR_SELECTION")

man.SelectLayerByAttribute(in_layer_or_view = "folyok_retegkent", selection_type = "CLEAR_SELECTION")
print(man.GetCount(in_rows = "folyok_retegkent")) # 49
man.SelectLayerByAttribute(in_layer_or_view = "varosok_retegkent", selection_type = "NEW_SELECTION", where_clause = "\"area\" > 200000")
print(man.GetCount(in_rows = "varosok_retegkent")) # 222
man.SelectLayerByLocation(in_layer = "folyok_retegkent", overlap_type = "WITHIN", select_features = "varosok_retegkent", selection_type = "NEW_SELECTION")
print(man.GetCount(in_rows = "folyok_retegkent")) # 6
man.SelectLayerByAttribute(in_layer_or_view = "varosok_retegkent", selection_type = "SWITCH_SELECTION")
print(man.GetCount(in_rows = "varosok_retegkent")) # 307
man.SelectLayerByLocation(in_layer = "folyok_retegkent", overlap_type = "INTERSECT", select_features = "varosok_retegkent", search_distance = "2000 Meters", selection_type = "ADD_TO_SELECTION")
print(man.GetCount(in_rows = "folyok_retegkent")) # 39
man.SelectLayerByAttribute(in_layer_or_view = "folyok_retegkent", selection_type = "REMOVE_FROM_SELECTION", where_clause = "\"name\" = 'Duna'")
print(man.GetCount(in_rows = "folyok_retegkent")) # 29
man.CopyFeatures(in_features = "folyok_retegkent", out_feature_class = "folyok_kivalasztott.shp")
man.DeleteFeatures(in_features = "folyok_retegkent") # törli a kijelölt elemeket
print(man.GetCount(in_rows = "folyok_retegkent")) # 20 (49 - 29)

man.MakeFeatureLayer(in_features = "varosok.shp", out_layer = "budapest")
man.SelectLayerByAttribute(in_layer_or_view = "budapest", selection_type = "NEW_SELECTION", where_clause = "\"id1\" = 2215")
print(man.GetCount(in_rows = "budapest")) # 1
man.Copy(in_data = "folyok.shp", out_data = "folyok3.shp")
ana.Clip(in_features = "folyok3.shp", clip_features = "budapest", out_feature_class = "folyok_budapesten.shp")

man.MakeFeatureLayer(in_features = "folyok3.shp", out_layer = "aranyhegyi")
man.SelectLayerByAttribute(in_layer_or_view = "aranyhegyi", selection_type = "NEW_SELECTION", where_clause = "\"name\" = 'Aranyhegyi-patak' AND \"length\" > 10")
ana.Buffer(in_features = "aranyhegyi", out_feature_class = "aranyhegyi_puffer.shp", buffer_distance_or_field = "3000 Meters")
ana.Buffer(in_features = "budapest", out_feature_class = "budapest_kicsinyitett.shp", buffer_distance_or_field = "-3 Kilometers")

ana.Union(in_features = ["aranyhegyi_puffer.shp", "budapest_kicsinyitett.shp"], out_feature_class = "unio.shp")
ana.Intersect(in_features = ["aranyhegyi_puffer.shp", "budapest_kicsinyitett.shp"], out_feature_class = "metszet.shp")
ana.Erase(in_features = "aranyhegyi_puffer.shp", erase_features = "budapest_kicsinyitett.shp", out_feature_class = "kulonbseg.shp")
ana.SymDiff(in_features = "aranyhegyi_puffer.shp", update_features = "budapest_kicsinyitett.shp", out_feature_class = "szimmetrikus_kulonbseg.shp")

man.CreateRandomPoints(out_path = arcpy.env.workspace, out_name = "100_pont_budapesten.shp", constraining_feature_class = "budapest", number_of_points_or_field = 100)
man.CreateRandomPoints(out_path = arcpy.env.workspace, out_name = "30_pont_pilisben.shp", constraining_extent = arcpy.Describe("pilis_dem.tif").extent, number_of_points_or_field = 30)
